
/******************************************************************************
* MODULE     : mmlout.cpp
* DESCRIPTION: Standard output facilities and switches
* COPYRIGHT  : (C) 2003  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "string.hpp"
#include "rational.hpp"
namespace mml {

nat   the_series_prec   = 10;
nat   the_series_zt     = 25;
char* the_series_var    = "z";
bool  the_series_expr   = false;
char* the_polynomial_var= "x";

content as_content (int i) { return content (i); }
content as_content (nat i) { return content (integer (i)); }
content as_content (unsigned long int i) { return content (integer (i)); }
content as_content (signed long int i) { return content (integer (i)); }
content as_content (char* s) { return content (s); }
content as_content (const string& s) { return content (s); }
content as_content (const integer& i) { return content (i); }
content as_content (const rational& r) { return content (r); }
content as_content (const symbolic& s) { return content (s); }

} // namespace mml
