
/******************************************************************************
* MODULE     : symbolic_defs.hpp
* DESCRIPTION: Global definitions for symbolic expressions
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#ifndef __SYMBOLIC_CST_HPP
#define __SYMBOLIC_CST_HPP
namespace mml {

enum sym_type {
  TYPE_UNKNOWN,
  TYPE_ATOM,
  TYPE_INTEGER,
  TYPE_RATIONAL,
  TYPE_COMPOUND,
  TYPE_SUM
};

class symbolic;
extern symbolic SYMB_ZERO;
extern symbolic SYMB_ONE;
extern symbolic SYMB_LESSLESS;
extern symbolic SYMB_GTRGTR;
extern symbolic SYMB_IMPLIES;
extern symbolic SYMB_EQUIV;
extern symbolic SYMB_OR;
extern symbolic SYMB_XOR;
extern symbolic SYMB_AND;
extern symbolic SYMB_EQUAL;
extern symbolic SYMB_UNEQUAL;
extern symbolic SYMB_LESS;
extern symbolic SYMB_LESSEQ;
extern symbolic SYMB_GTR;
extern symbolic SYMB_GTREQ;
extern symbolic SYMB_FUNCTION;
extern symbolic SYMB_PLUS;
extern symbolic SYMB_TIMES;
extern symbolic SYMB_OVER;
extern symbolic SYMB_COMPOSE;
extern symbolic SYMB_NOT;
extern symbolic SYMB_MINUS;
extern symbolic SYMB_POWER;
extern symbolic SYMB_FACTORIAL;
extern symbolic SYMB_PRIME;
extern symbolic SYMB_DOT;
extern symbolic SYMB_ACCESS;
extern symbolic SYMB_TUPLE;
extern symbolic SYMB_VTUPLE;
extern symbolic SYMB_SQTUPLE;

#define PRIORITY_ATOMIC      0
#define PRIORITY_INTEGER     1
#define PRIORITY_RATIONAL    2
#define PRIORITY_COMPOUND    3
#define PRIORITY_PRODUCT     4
#define PRIORITY_SUM         5
#define PRIORITY_MODIFIED    6
#define PRIORITY_CONSTRAINT  7

} // namespace mml
#endif // __extern symbolic SYMBOLIC_CST_HPP
