
/******************************************************************************
* MODULE     : symbolic.cpp
* DESCRIPTION: Symbolic expressions
* COPYRIGHT  : (C) 2004  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include "symbolic_aux.hpp"
namespace mml {

sym_type symbolic_rep::type () { assert (false); return TYPE_UNKNOWN; }
nat symbolic_rep::priority () { return PRIORITY_ATOMIC; }
bool symbolic_rep::is_atomic () { return true; }
string symbolic_rep::leaf () { assert (false); return ""; }
nat symbolic_rep::arity () { return 0; }
symbolic symbolic_rep::child (nat i) { assert (false); return 0; }
nat symbolic_rep::hash () { return 0; }
bool symbolic_rep::identical (symbolic_rep* rep) { return this == rep; }

symbolic::symbolic (symbolic_rep* rep2): rep (memorize (rep2)) {}
symbolic::~symbolic () { forget (rep); DEC_COUNT (rep); }
symbolic& symbolic::operator = (const symbolic& x) {
  INC_COUNT (x.rep); forget (rep); DEC_COUNT (rep);
  rep=x.rep; return *this; }

} // namespace mml
